function  func = Relax(image,iterator,output_file)
matrix = imread(image);
[rows,columns] = size(matrix);
paddedMatrix = ones(rows+2,columns+2); % creating the 'padding' since we check neighbours of each pixel
paddedMatrix=paddedMatrix*127;
for i=1 : rows
    for j=1:columns
        paddedMatrix(i+1,j+1) = matrix(i,j);
    end
end
prob_grapgh = zeros(rows+2,columns+2,2);
for i=2:rows+1
    for j = 2:columns+1
        x = i-1;
        y = j-1;
        back_prob = 0;
        obj_prob=0;
        if (paddedMatrix(i-1,j-1)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
        end
        if (paddedMatrix(i,j-1)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
        end
         if (paddedMatrix(i-1,j)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
         end
         if (paddedMatrix(i+1,j)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
         end
         if (paddedMatrix(i,j+1)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
         end
         if (paddedMatrix(i+1,j-1)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
         end
         if (paddedMatrix(i-1,j+1)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
         end
         if (paddedMatrix(i+1,j+1)>127)
            back_prob=back_prob+1;
        else
            obj_prob = obj_prob +1;
         end
        back_prob=back_prob/8;
        obj_prob = obj_prob/8;
        prob_grapgh(i,j,1)=back_prob;
        prob_grapgh(i,j,2)=obj_prob;
    end
end


next_step_prob_graph = zeros(rows+2,columns+2,2);
while iterator>0
    for i=2:rows+1
        for j=2:columns+1
            g = (prob_grapgh(i,j,1)*support(i,j,prob_grapgh,0) + prob_grapgh(i,j,2)*support(i,j,prob_grapgh,1) );
            if (g==0)
                g=1;
            end
            next_step_prob_graph(i,j,1) = (prob_grapgh(i,j,1)*support(i,j,prob_grapgh,0) )/g;
            next_step_prob_graph(i,j,2) =  (prob_grapgh(i,j,2)*support(i,j,prob_grapgh,1) )/g;
        end
    end
    prob_grapgh = next_step_prob_graph;
    iterator = iterator-1;
end


res = zeros(rows,columns);
for i=2:rows+1
        for j=2:columns+1
            prob1 = prob_grapgh(i,j,1);
            prob2 = prob_grapgh(i,j,2);
            if ( prob1>prob2)
                res(i-1,j-1)=0;
            else
                res(i-1,j-1)=1;
            end
        end
end
res= res*255;
imwrite(res,output_file,'JPG');


        
        